//-*-c++-*-
#ifndef INCLUDED_SquareDetectorTest_h_
#define INCLUDED_SquareDetectorTest_h_


#include "Behaviors/BehaviorBase.h"
#include "Events/EventRouter.h"
#include "Events/VisionObjectEvent.h"
#include "Vision/BallDetectionGenerator.h"
#include "local_interface.h"
#include "detectors/LandmarkDetectionGenerator.h"

using namespace std; 

//! DESCRIPTION
class SquareDetectorTest : public BehaviorBase {
public:
	LandmarkDetectionGenerator* det;

	//! constructor
	SquareDetectorTest() : BehaviorBase("SquareDetectorTest"),
		det(new LandmarkDetectionGenerator()) {
		det->DoStart();
		}

	virtual void DoStart() {
		BehaviorBase::DoStart(); // do this first (required)

		erouter->addListener(this,EventBase::visObjEGID);
	}

	virtual void DoStop() {
		det->DoStop();
		
		// <your shutdown code here>

		erouter->removeListener(this); //generally a good idea, unsubscribe all
		BehaviorBase::DoStop(); // do this last (required)
	}

	virtual void processEvent(const EventBase& e) {
		if(e.getSourceID() == LawrenceInterface::visLMSID) {
			cout << "Landmark event:" << endl;
			det->getNode()->print();
		}


/*		if(e.getGeneratorID() == EventBase::visObjEGID) {
			const VisionObjectEvent &visev = dynamic_cast<const VisionObjectEvent&>(e);
			if(visev.getSourceID() == LawrenceInterface::visLMPSID) cout << "Pink square";
			else if(visev.getSourceID() == LawrenceInterface::visLMYSID) cout << "Yellow square";
			else if(visev.getSourceID() == LawrenceInterface::visLMBSID) cout << "Blue square";
			else if(visev.getSourceID() == LawrenceInterface::visLMGSID) cout << "Green square";
			else cout << "Unrecognized square color";		

	    	if ( visev.getTypeID() == EventBase::activateETID || visev.getTypeID() == EventBase::statusETID )
				std::cout << " at ( " <<
				  	visev.getCenterX() << " , " << visev.getCenterY() << " )" << std::endl;
	      	else    // deactivateETID
				std::cout << "\nlost sight of the square." << std::endl;
		}
		else std::cout << getClassName() << " got an unexpected event!" << std::endl;
*/
	}

	static std::string getClassDescription() { return "tests the functionality of the square detector"; }
	

protected:
	// <class members go here>

	
private:
	// Providing declarations for these functions will avoid a compiler warning if
	// you have any class members which are pointers.  However, as it is, an error
	// will result if you inadvertantly cause a call to either (which is probably
	// a good thing, unless you really intended to copy/assign a behavior, in
	// which case simply provide implementations for the functions)
	SquareDetectorTest(const SquareDetectorTest&); //!< don't call (copy constructor)
	SquareDetectorTest& operator=(const SquareDetectorTest&); //!< don't call (assignment operator)
};

/*! @file
 * @brief Defines SquareDetectorTest, which tests the functionality of the square detector
 * @author Daniel Casner (Creator)
 *
 */
 
#endif
