//-*-c++-*-
#ifndef INCLUDED_LandmarkDetectionGenerator_h_
#define INCLUDED_LandmarkDetectionGenerator_h_

// This is an empty Behavior template file.
// Replace YOURNAMEHERE, LandmarkDetectionGenerator, and DESCRIPTION as appropriate, and go to town!

#include "Behaviors/BehaviorBase.h"
#include "Events/EventRouter.h"
#include "Events/VisionObjectEvent.h"
#include "Vision/BallDetectionGenerator.h"
#include "lawrence/mapNode.h"

//! DESCRIPTION
class LandmarkDetectionGenerator : public BehaviorBase {
public:
	//! constructor
	LandmarkDetectionGenerator();

	virtual void DoStart();
	virtual void DoStop();
	
	virtual void processEvent(const EventBase& e);

	MapNode* getNode();

	static std::string getClassDescription() { return "DESCRIPTION"; }
	virtual std::string getDescription() const { return getClassDescription(); }
	

protected:
	double confidence;
	
	/* Returns a mapnode with the configuration seen if it is a landmark
	 * or NULL if it was not a landmark */
	MapNode* determineLandmark();
	
	static LMColors colorByElimination(LMColors a, LMColors b, LMColors c);
	static float computeDist(x1, y1, x2, y2);
	
private:
	static const unsigned int NUM_SQUARES = 4;
	
	/* pointers to store corolated vision events
	 * squares[0]	pink
	 * squares[1]	blue
	 * squares[2]	yellow
	 * squares[3]	green */
	const VisionObjectEvent* squares[NUM_SQUARES];
	MapNode* node;

	// Providing declarations for these functions will avoid a compiler warning if
	// you have any class members which are pointers.  However, as it is, an error
	// will result if you inadvertantly cause a call to either (which is probably
	// a good thing, unless you really intended to copy/assign a behavior, in
	// which case simply provide implementations for the functions)
	LandmarkDetectionGenerator(const LandmarkDetectionGenerator&); //!< don't call (copy constructor)
	LandmarkDetectionGenerator& operator=(const LandmarkDetectionGenerator&); //!< don't call (assignment operator)
};

/*! @file
 * @brief Defines LandmarkDetectionGenerator, which DESCRIPTION
 * @author YOURNAMEHERE (Creator)
 *
 * $Author$
 * $Name$
 * $Revision$
 * $State$
 * $Date$
 */

#endif
