//-*-c++-*-
#ifndef INCLUDED_TEST_h_
#define INCLUDED_TEST_h_


#include "Behaviors/BehaviorBase.h"
#include "Events/EventRouter.h"
#include "Motion/MotionManager.h"
#include "Motion/MMAccessor.h"
#include "Motion/HeadPointerMC.h"
#include "Shared/WorldState.h"
#include "Shared/ERS7Info.h"

//! DESCRIPTION
class test : public BehaviorBase {
public:
	//! constructor
	test() : BehaviorBase("test"),headpointer_id(MotionManager::invalid_MC_ID), motNumber(0), moveDir(0) {}

	virtual void DoStart() {
		BehaviorBase::DoStart(); // do this first (required)
		
		headpointer_id = motman->addPersistentMotion(SharedObject<HeadPointerMC>());
		erouter->addListener(this,EventBase::buttonEGID);
	}

	virtual void DoStop() {
		// <your shutdown code here>
		motman->removeMotion(headpointer_id);
		erouter->removeListener(this); //generally a good idea, unsubscribe all
		BehaviorBase::DoStop(); // do this last (required)
	}

	virtual void processEvent(const EventBase& e) {
		// <your event processing code here>
		// you can delete this function if you don't use any events...
		// (in which case, you may want to call DoStop() at the end of DoStart()
		if(e.getGeneratorID() == EventBase::buttonEGID) {
			switch(motNumber) {
			case 0:
std::cout << "LocateDestination: mot" << motNumber << " (0)" << endl;
				MMAccessor<HeadPointerMC>(headpointer_id)->setJoints(tiltTop,-M_PI/2,0);
				moveDir = 0;
				motNumber++;
				break;
			case 1:
std::cout << "LocateDestination: mot" << motNumber << " (1)" << endl;
				MMAccessor<HeadPointerMC>(headpointer_id)->setJoints(tiltTop,0,0);
				(moveDir == 0) ? motNumber++ : motNumber--;
				break;
			case 2:
std::cout << "LocateDestination: mot" << motNumber << " (2)" << endl;
				MMAccessor<HeadPointerMC>(headpointer_id)->setJoints(tiltTop,M_PI/2,0);
				moveDir = 1;
				motNumber--;
				break;
			}
		}
	}

	static std::string getClassDescription() { return "walks down the hallway without crashing into anything (almost anything)"; }
	virtual std::string getDescription() const { return getClassDescription(); }
	

protected:
	// <class members go here>
	MotionManager::MC_ID headpointer_id; // a HeadPointerMC object	
	static const float tiltTop = 0.2;
	short motNumber;
	short moveDir;
	
private:
	// Providing declarations for these functions will avoid a compiler warning if
	// you have any class members which are pointers.  However, as it is, an error
	// will result if you inadvertantly cause a call to either (which is probably
	// a good thing, unless you really intended to copy/assign a behavior, in
	// which case simply provide implementations for the functions)
	test(const test&); //!< don't call (copy constructor)
	test& operator=(const test&); //!< don't call (assignment operator)
};

/*! @file
 * @brief Defines test, which walks down the hallway without crashing into anything (almost anything)
 * @author bw & dc (Creator)
 *
 * $Author$
 * $Name$
 * $Revision$
 * $State$
 * $Date$
 */

#endif
