//-*-c++-*-
#ifndef INCLUDED_comm_demo
#define INCLUDED_comm_demo



#include "Behaviors/BehaviorBase.h"
#include "Events/EventRouter.h"
#include "Wireless/Wireless.h"


//! Socket Communication Proof of Concept
class comm_demo : public BehaviorBase {
public:
	//! constructor
	comm_demo();
	~comm_demo();

	virtual void DoStart();
	virtual void DoStop();
	virtual void processEvent(const EventBase& e);
	static std::string getClassDescription() { return "Socket Communication Proof of Concept"; }
	virtual std::string getDescription() const { return getClassDescription(); }
	
	enum commTask { server,slave };

protected:
	// <class members go here>
	Socket *theSock;

	//startup code for larry
	virtual void SetupServer();
	//startup code for cody
	virtual void SetupSlave();
	//shutdown code for larry
	virtual void ShutdownServer();
	//shutdown code for cody
	virtual void ShutdownSlave();
	//timer code for larry
	virtual void TickServer();
	//timer code for cody
	virtual void TickClient();
	

	

	
	commTask myTask;
	
private:
	// Providing declarations for these functions will avoid a compiler warning if
	// you have any class members which are pointers.  However, as it is, an error
	// will result if you inadvertantly cause a call to either (which is probably
	// a good thing, unless you really intended to copy/assign a behavior, in
	// which case simply provide implementations for the functions)
	comm_demo(const comm_demo&); //!< don't call (copy constructor)
	comm_demo& operator=(const comm_demo&); //!< don't call (assignment operator)
};

/*! @file
 * @brief Defines comm_demo, which is a Socket Communication Proof of Concept
 * @author BW & DC
 *
 * $Author$
 * $Name$
 * $Revision$
 * $State$
 * $Date$
 */

#endif
